
%% 
function [result,no] = cinc_challenge(ecg_data,ppg_data,Fs,plot_pt,arr_string)

arr = 0;
result = -1;
no = 0;

start = 290*Fs+1;
finish = 300*Fs;
ecg_data = ecg_data(start:finish);
ppg_data = ppg_data(start:finish);

if (strcmp(arr_string,'Bradycardia'))
    arr = 1;
elseif (strcmp(arr_string,'Tachycardia'))
    arr = 2;
elseif (strcmp(arr_string,'Asystole'))
    arr = 3;
elseif (strcmp(arr_string,'Ventricular_Tachycardia'))
    arr = 4;
elseif (strcmp(arr_string,'Ventricular_Flutter_Fib'))
    arr = 5;    
end
    
if(arr ~= 0 && arr <= 2)

    ecg_flcheck = check_flatline(ecg_data,Fs,arr,1,1);
    ppg_flcheck = check_flatline(ppg_data,Fs,arr,2,1);
    
    if(ecg_flcheck == 1)
        
        if(~ppg_flcheck)
            if(arr == 1)
                pk = get_ppgpeaks(ppg_data,1.1,Fs,2);
            elseif(arr == 2)
                pk = get_ppgpeaks(ppg_data,1.1,Fs,2);
            else
                pk = get_ppgpeaks(ppg_data,1.0,Fs,2);
            end
            result = check_arr(pk,Fs,arr);
            no = 1;
        else
            result = 0;
            no = 2;
        end
    else
        
        ecg_data1 = butter_bidir(1,ecg_data,Fs,4,'low');
        ecg_data2 = ecg_data - ecg_data1;
        ecg_data = ecg_data2;
        
        
        ri = get_ecgpeaks(ecg_data,Fs,plot_pt,arr);
        [result_ecg,set,blk,avg_hr] = check_arr(ri,Fs,arr);
        result = result_ecg;
        pk = [];
        if(~ppg_flcheck)
            pk = get_ppgpeaks(ppg_data,avg_hr,Fs,arr);
        end
        
        if(~isempty(blk))
            
            [m,~] = size(blk);
            
            for i=1:1:m
                
                first = ri(blk(i,1));
                last = ri(blk(i,2));
                
                ecg_flcheck = check_flatline(ecg_data(first:last),Fs,1);
                
                if(ecg_flcheck)
                    continue;
                end
                
                if(result == 1 && m==1)
                    result_ppg = verify_ppg(ppg_data,first,last,Fs,ppg_flcheck,result_ecg,pk,arr);

                    if(result_ecg == result_ppg)
                        result = result_ecg;
                        no = 3;

                    else
                        no = 4;

                        result = 1 - result_ecg;
                    end
                end
            end
            
        elseif(~isempty(set))

            first = ri(set(1,1));
            last = ri(set(1,2));
            
            if(result == 1)
                result_ppg = verify_ppg(ppg_data,first,last,Fs,ppg_flcheck,result_ecg,pk,arr);

                if(result_ecg == result_ppg)
                    result = result_ecg;
                    no = 5;
                else
                    no = 6;
                    result = 1 - result_ecg;
                end
            end
        end
    end
end